diff -uwr source/scripts/dp88_ar.cpp 4.0/source/scripts/dp88_ar.cpp
--- source/scripts/dp88_ar.cpp	2011-07-25 18:12:28.000000000 +0800
+++ 4.0/source/scripts/dp88_ar.cpp	2011-10-25 07:50:47.750976500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for the ApocRising total conversion mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,7 +9,6 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 // Include files
 #include "general.h"
 #include "scripts.h"
@@ -247,43 +245,11 @@
 
 void dp88_AR_GameController::Custom ( GameObject *obj, int type, int param, GameObject *sender )
 {
-/*	if ( type == CUSTOM_TD_WAITINGFORPURCHASE )
-	{
-		if ( TD_Waiting_Console == 0 )
-		{
-			Console_Output ( "TD console reported to game controller OK! OK to proceed\n" );
-			// Report that the request has been accepted
-			TD_Waiting_Console = Commands->Get_ID ( sender );
-			Commands->Send_Custom_Event ( obj, sender, CUSTOM_TD_PURCHASEWAIT_OK, 1, 0.0 );
-
-			// Begin time-out timer
-			Commands->Start_Timer ( obj, this, 4.0, TIMER_TD_PURCHASETIMEEXPIRED );
-		}
-		else
-		{
-			Console_Output ( "TD console reported to game controller OK! Asked to wait...\n" );
-			// Report that we are busy, and get them to wait a bit
-			Commands->Send_Custom_Event ( obj, sender, CUSTOM_TD_PURCHASEWAIT_OK, 0, 0.0 );
-		}
-	}
-
-	else if ( type == CUSTOM_TD_REPORTCREATION )
-	{
-		if ( TD_Waiting_Console != 0 )
-		{
-			Commands->Send_Custom_Event ( obj, Commands->Find_Object( TD_Waiting_Console ), CUSTOM_TD_REPORTCREATION, Commands->Get_ID( sender ), 0.0 );
-			TD_Waiting_Console = 0;
-		}
-	}*/
 }
 
 
 void dp88_AR_GameController::Timer_Expired( GameObject *obj, int number )
 {
-	/*if ( number == TIMER_TD_PURCHASETIMEEXPIRED )
-	{
-		TD_Waiting_Console = 0;
-	}*/
 }
 
 
@@ -1087,7 +1053,7 @@
 	seconds, which will cause the AI to set off towards an ore field. Note that the
 	delay is required to prevent the normal harvester AI taking over */
 	if ( useAI )
-		Commands->Send_Custom_Event( obj, obj, CUSTOM_MINER_UNLOAD_ORE_COMPLETE, 1, 10.0f );
+		Commands->Send_Custom_Event( obj, obj, CUSTOM_MINER_UNLOAD_ORE_COMPLETE, 1, (float)Get_Int_Parameter("aiStartDelay") );
 }
 
 
@@ -1827,48 +1793,67 @@
 
 void dp88_RemoteControlConsole::Created ( GameObject *obj )
 {
-	Console_Output ( "[%d:%s:%s] Created - remoteControlID %d\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Int_Parameter("remoteControlID") );
+	//Console_Output ( "[%d:%s:%s] Created - remoteControlID %d\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Int_Parameter("remoteControlID") );
 
 	vehicleID		= NULL;
 	pilotID			= NULL;
-	pilotDummyID	= NULL;
-	enabled			= true;
+	m_pilotDummyID	= NULL;
+	m_bEnabled		= true;
+	m_nChargeTime	= Get_Int_Parameter ( "chargeTime" );
 
-	Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	// Start charge tick timer if necessary and set initial animation frames
+	if ( m_nChargeTime > 0 )
+	{
+		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+	}
+	else
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+
+	Commands->Enable_HUD_Pokable_Indicator(obj, (m_nChargeTime == 0));
 }
 
 void dp88_RemoteControlConsole::Poked ( GameObject *obj, GameObject *poker )
 {
-	Console_Output ( "[%d:%s:%s] Poked\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+	//Console_Output ( "[%d:%s:%s] Poked\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 
 	// Check the team of the poker
 	int team = Get_Int_Parameter("team");
 	if ( team != 2 && Get_Object_Type(poker) != team )
 	{
-		Console_Output ( "[%d:%s:%s] DENIED OMFG\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Console access denied\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		// Play access denied sound
 		Create_2D_Sound_Player(poker, Get_Parameter("accessDeniedSound") );
 		return;
 	}
 
 	// Check if the terminal is offline
-	if ( !enabled )
+	if ( !m_bEnabled )
 	{
-		Console_Output ( "[%d:%s:%s] OFFLINE OMFG\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Console is offline\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		// Play console offline sound
 		Create_2D_Sound_Player(poker, Get_Parameter("consoleOfflineSound") );
 		return;
 	}
 
+	// Check if the terminal is charging
+	if ( m_nChargeTime > 0 )
+	{
+		//Console_Output ( "[%d:%s:%s] Console still charging\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		// Play console charging sound
+		Create_2D_Sound_Player(poker, Get_Parameter("consoleChargingSound") );
+		return;
+	}
+
 	// If no vehicle currently exists then create one
 	if ( pilotID == NULL && vehicleID == NULL )
 	{
-		Console_Output ( "[%d:%s:%s] BUYING\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] BUYING\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		// Try to purchase the unit, will fail if we don't have enough money
 		int cost = Get_Int_Parameter ( "cost" );
 		if ( !Purchase_Item(poker, cost ) )
 		{
-			Console_Output ( "[%d:%s:%s] NO NOOLAH\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+			//Console_Output ( "[%d:%s:%s] NO NOOLAH\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 			// Play insufficient funds denied sound
 			Create_2D_Sound_Player(poker, Get_Parameter("insufficientFundsSound") );
 			return;
@@ -1882,17 +1867,22 @@
 		Commands->Enable_HUD_Pokable_Indicator(obj, false);
 
 		// ...Then create the vehicle...
-		Console_Output ( "[%d:%s:%s] Creating remote control vehicle %s\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Parameter ( "vehiclePreset" ) );
-		Create_Vehicle( Get_Parameter ( "vehiclePreset" ), 0.0, Commands->Find_Object( pilotID ), Get_Object_Type( Commands->Find_Object(pilotID) ) );
-
+		//Console_Output ( "[%d:%s:%s] Creating remote control vehicle %s\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Parameter ( "vehiclePreset" ) );
+		if (!Create_Vehicle( Get_Parameter ( "vehiclePreset" ), 0.0, Commands->Find_Object( pilotID ), Get_Object_Type( Commands->Find_Object(pilotID) ) ))
+		{
+			Timer_Expired(obj,TIMER_REMOTECONTROL_TIMEOUT);
+		}
+		else
+		{
 		// And wait for confirmation... start a timer in the event that we don't ever get this...
 		Commands->Start_Timer ( obj, this, 5.0, TIMER_REMOTECONTROL_TIMEOUT );
 	}
+	}
 
 	// OK, a vehicle already exists, does it have a pilot? If not then take control of it
 	else if ( pilotID == NULL )
 	{
-		Console_Output ( "[%d:%s:%s] ENTER EXISTING\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] ENTER EXISTING\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		// Enable transitions and wait until they are active to put driver in
 		GameObject* vehicle = Commands->Find_Object(vehicleID);
 		if ( vehicle )
@@ -1915,10 +1905,10 @@
 
 void dp88_RemoteControlConsole::Custom( GameObject *obj, int type, int param, GameObject *sender )
 {
-	Console_Output ( "[%d:%s:%s] Custom %d - %d\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), type, param );
+	//Console_Output ( "[%d:%s:%s] Custom %d - %d\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), type, param );
 	if ( type == CUSTOM_REMOTECONTROL_CREATED && param == Get_Int_Parameter("remoteControlID") && vehicleID == NULL && pilotID != NULL )
 	{
-		Console_Output ( "[%d:%s:%s] Sending console ID to unit\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Sending console ID to unit\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 
 		// Inform the remote control unit that this is it's console (we do this to prevent multiple
 		// consoles trying to control the same unit if two are created close together)
@@ -1930,7 +1920,7 @@
 
 	else if ( type == CUSTOM_REMOTECONTROL_CONSOLEACK )
 	{
-		Console_Output ( "[%d:%s:%s] Recieved ACK from unit, establishing control\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Recieved ACK from unit, establishing control\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 
 		// The remote control unit has accepted us as it's control console
 		vehicleID = Commands->Get_ID(sender);
@@ -1942,26 +1932,15 @@
 
 	else if ( type == CUSTOM_REMOTECONTROL_DRIVEREXIT )
 	{
-		Console_Output ( "[%d:%s:%s] Driver exited, remote control unit now idle\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
-
-		GameObject* pilot = Commands->Find_Object(pilotID);
-		if ( pilot )
-			Commands->Set_Position ( Commands->Find_Object ( pilotID ), pilotDummyPos );
+		//Console_Output ( "[%d:%s:%s] Driver exited, remote control unit now idle\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		DestroyDummy();
+		HandleDriverExit ( obj, Commands->Find_Object(pilotID), sender );
 		pilotID = NULL;
-
-		// Set team to correct setting (so it gives points for being damaged)
-		Set_Object_Type ( sender, Get_Int_Parameter("team") );
-
-		// Disable transitions on remote vehicle
-		Commands->Enable_Vehicle_Transitions( sender, false );
-
-		// Enable pokeable indicator
-		Commands->Enable_HUD_Pokable_Indicator(obj, true);
 	}
 
 	else if ( type == CUSTOM_REMOTECONTROL_DESTROYED )
 	{
-		Console_Output ( "[%d:%s:%s] Remote control unit was destroyed\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Remote control unit was destroyed\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 
 		vehicleID = NULL;
 
@@ -1969,8 +1948,32 @@
 		if ( pilotID != NULL )
 			Commands->Start_Timer ( obj, this, 0.5, TIMER_REMOTECONTROL_DRIVEREXIT );
 
-		// Enable pokeable indicator
-		Commands->Enable_HUD_Pokable_Indicator(obj, true);
+		// Reset charge time
+		m_nChargeTime	= Get_Int_Parameter ( "chargeTime" );
+
+		// Start charge tick timer if necessary and set initial animation frames
+		if ( m_bEnabled )
+		{
+			if ( m_nChargeTime > 0 )
+			{
+				Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
+				Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+			}
+			else
+				Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+		}
+
+		Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
+	}
+
+	else if ( type == CUSTOM_REMOTECONTROL_DISABLED )
+	{
+		SetEnabled(obj, false);
+	}
+
+	else if ( type == CUSTOM_REMOTECONTROL_ENABLED )
+	{
+		SetEnabled(obj, true);
 	}
 }
 
@@ -1979,7 +1982,7 @@
 {
 	if ( number == TIMER_REMOTECONTROL_TIMEOUT && vehicleID == 0 )
 	{
-		Console_Output ( "[%d:%s:%s] Purchase timed out, refunding money and freeing pilot\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Purchase timed out, refunding money and freeing pilot\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 
 		GameObject* pilot = Commands->Find_Object(pilotID);
 		if ( pilot )
@@ -1990,20 +1993,19 @@
 		pilotID = NULL;
 
 		// Enable pokeable indicator
-		Commands->Enable_HUD_Pokable_Indicator(obj, true);
+		Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
 	}
 
 
 	else if ( number == TIMER_REMOTECONTROL_DRIVERENTER )
 	{
-		Console_Output ( "[%d:%s:%s] Transitioning driver into vehicle\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
-
+		//Console_Output ( "[%d:%s:%s] Transitioning driver into vehicle\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		GameObject* vehicle = Commands->Find_Object(vehicleID);
 		GameObject* pilot = Commands->Find_Object(pilotID);
 		if ( pilot )
 		{
 			// Create pilot dummy...
-			pilotDummyPos = Commands->Get_Position ( Commands->Find_Object ( pilotID ) );
+			CreateDummy ( pilot, Commands->Get_Position(pilot), Commands->Get_Facing(pilot) );
 
 			Commands->Control_Enable ( pilot, true );
 			Commands->Set_Position ( pilot, Commands->Get_Position ( vehicle ) );
@@ -2011,6 +2013,9 @@
 
 			// Play control established sound
 			Create_2D_Sound_Player(pilot, Get_Parameter("connectionEstablishedSound") );
+
+			// Set animation frame
+			Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
 		}
 		else	// This should never actually happen... but just in case...
 		{
@@ -2018,21 +2023,142 @@
 			pilotID = NULL;
 
 			// Enable pokeable indicator
-			Commands->Enable_HUD_Pokable_Indicator(obj, true);
+			Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
 		}
 	}
 
 
+	// This can be called for the vehicle being destroyed OR the console becoming disabled
 	else if ( number == TIMER_REMOTECONTROL_DRIVEREXIT )
 	{
+		DestroyDummy();
+		HandleDriverExit ( obj, Commands->Find_Object(pilotID), Commands->Find_Object(vehicleID) );
+		pilotID = NULL;
+	}
+
+
+	// Count down tick for charge time
+	else if ( number == TIMER_REMOTECONTROL_CHARGETICK )
+	{
+		if ( m_bEnabled )
+		{
+			m_nChargeTime--;
+			if ( m_nChargeTime > 0 )
+				Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
+			else
+			{
+				Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+				Commands->Enable_HUD_Pokable_Indicator(obj, true);
+			}
+		}
+	}
+}
+
+void dp88_RemoteControlConsole::SetEnabled ( GameObject* obj, bool state )
+{
+	if ( state == m_bEnabled )
+		return;
+
+	m_bEnabled = state;
+
+	// If we are no longer enabled evict the driver
+	if ( !m_bEnabled && pilotID != NULL )
+	{
 		GameObject* pilot = Commands->Find_Object(pilotID);
 		if ( pilot )
+		{
+			Soldier_Transition_Vehicle ( pilot );
+			Create_2D_Sound_Player(pilot, Get_Parameter("consoleOfflineSound") );
+			Commands->Start_Timer ( obj, this, 0.5, TIMER_REMOTECONTROL_DRIVEREXIT );
+		}
+	}
+
+	// Set pokeable indicator state
+	Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
+
+	// Update the animation frame state
+	if ( !m_bEnabled )
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+	else if ( m_nChargeTime > 0 )
+	{
+		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+	}
+	else
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+}
+
+void dp88_RemoteControlConsole::CreateDummy ( GameObject* pilot, Vector3 position, float facing )
+{
+	GameObject* dummy = Commands->Create_Object ( "Invisible_Object", position );
+	if ( dummy )
+	{
+		m_pilotDummyID = Commands->Get_ID(dummy);
+		Commands->Set_Facing(dummy, facing);
+		pilotDummyPos = position;	// Used to put the pilot back in his original location
+
+		// Clone health/armour
+		Set_Skin(dummy, Get_Skin(pilot) );
+		Commands->Set_Shield_Type(dummy, Get_Shield_Type(pilot) );
+		Set_Max_Health(dummy, Commands->Get_Max_Health(pilot) );
+		Set_Max_Shield_Strength(dummy, Commands->Get_Max_Shield_Strength(pilot) );
+		Commands->Set_Health(dummy, Commands->Get_Health(pilot) );
+		Commands->Set_Shield_Strength(dummy, Commands->Get_Shield_Strength(pilot) );
+
+		// Link dummy and pilot health and armour
+		char pilotIdString[12];
+		sprintf ( pilotIdString, "%d", Commands->Get_ID(pilot) );
+		Attach_Script_Once ( dummy, "dp88_linkHealth", pilotIdString );
+
+		// Clone player model onto dummy
+		Commands->Set_Model ( dummy, Get_Model(pilot) );
+	}
+}
+
+void dp88_RemoteControlConsole::DestroyDummy()
+{
+	if ( m_pilotDummyID != NULL )
+	{
+		GameObject* dummy = Commands->Find_Object(m_pilotDummyID);
+		m_pilotDummyID = NULL;
+
+		// Destroy the dummy object rather than killing it - this prevents dp88_linkHealth from also
+		// killing the pilot
+		if ( dummy )
+			Commands->Destroy_Object(dummy);
+	}
+}
+
+void dp88_RemoteControlConsole::HandleDriverExit ( GameObject* obj, GameObject* pilot, GameObject* vehicle )
+{
+	if ( pilot )
 			Commands->Set_Position ( pilot, pilotDummyPos );
-		pilotID = NULL;
+
+	// If the vehicle is still alive set it to its idle state
+	if ( vehicle )
+	{
+		// Set team to correct setting (so it gives points for being damaged)
+		Set_Object_Type ( vehicle, Get_Int_Parameter("team") );
+
+		// Disable transitions on remote vehicle
+		Commands->Enable_Vehicle_Transitions( vehicle, false );
+	}
 
 		// Enable pokeable indicator
-		Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
+
+	// Set animation frame
+	if ( !m_bEnabled )
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+	else if ( vehicle )
+		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), true, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
+	else if ( m_nChargeTime > 0 )
+	{
+		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
 	}
+	else
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
 }
 
 
@@ -2044,7 +2170,7 @@
 
 void dp88_RemoteControlVehicle::Created ( GameObject *obj )
 {
-	Console_Output ( "[%d:%s:%s] Created - remoteControlID %d\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Int_Parameter("remoteControlID") );
+	//Console_Output ( "[%d:%s:%s] Created - remoteControlID %d\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name(), Get_Int_Parameter("remoteControlID") );
 
 	consoleID = NULL;
 	pilotID = NULL;
@@ -2082,7 +2208,7 @@
 	// to accept them as our controller
 	else if ( type == CUSTOM_REMOTECONTROL_CONSOLEID && consoleID == 0 )
 	{
-		Console_Output ( "[%d:%s:%s] Got console, sending ACK\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
+		//Console_Output ( "[%d:%s:%s] Got console, sending ACK\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
 		consoleID = Commands->Get_ID ( sender );
 		Commands->Send_Custom_Event(obj, sender, CUSTOM_REMOTECONTROL_CONSOLEACK, 1 ,0);
 	}
@@ -2921,8 +3047,8 @@
 ScriptRegistrant<dp88_AR_CLEG_target> dp88_AR_CLEG_target_Registrant( "dp88_AR_CLEG_target", "resistance=20:int,clegEffectPreset=null:string" );
 
 // Ore Harvesting
-ScriptRegistrant<dp88_AR_Miner> dp88_AR_Miner_Registrant("dp88_AR_War_Miner","enableAI=1:int,loadLevels=10:int,orePerLoadLevel=100:int,timePerLoadLevel=2.0:float,unloadTime=8.0:float");
-ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant("dp88_AR_Chrono_Miner","enableAI=1:int,chronoshift_time=2.5:float,chronoshift_out_effect_preset:string,chronoshift_out_effect_time:float,chronoshift_in_effect_preset:string,chronoshift_in_effect_time:float,chronoshiftKeyhook=VDeploy:string,loadLevels=10:int,orePerLoadLevel=50:int,timePerLoadLevel=1.00:float,unloadTime=4.0:float,emergencyChronoshiftHealthThreshold=30.0:float");
+ScriptRegistrant<dp88_AR_Miner> dp88_AR_Miner_Registrant("dp88_AR_War_Miner","enableAI=1:int,loadLevels=10:int,orePerLoadLevel=100:int,timePerLoadLevel=2.0:float,unloadTime=8.0:float,aiStartDelay=10:int");
+ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant("dp88_AR_Chrono_Miner","enableAI=1:int,chronoshift_time=2.5:float,chronoshift_out_effect_preset:string,chronoshift_out_effect_time:float,chronoshift_in_effect_preset:string,chronoshift_in_effect_time:float,chronoshiftKeyhook=VDeploy:string,loadLevels=10:int,orePerLoadLevel=50:int,timePerLoadLevel=1.00:float,unloadTime=4.0:float,emergencyChronoshiftHealthThreshold=30.0:float,aiStartDelay=10:int");
 ScriptRegistrant<dp88_AR_Chrono_Miner_Chronozone> dp88_AR_Chrono_Miner_Chronozone_Registrant("dp88_AR_Chrono_Miner_Chronozone","");
 ScriptRegistrant<dp88_AR_Ore_Field_Zone> dp88_AR_Ore_Field_Zone_Registrant("dp88_AR_Ore_Field_Zone","oreValue=1:int");
 ScriptRegistrant<dp88_AR_Ore_Deposit_Zone> dp88_AR_Ore_Deposit_Zone_Registrant("dp88_AR_Ore_Deposit_Zone","teamID=0:int");
@@ -2937,7 +3063,7 @@
 /*ScriptRegistrant<dp88_AR_TerrorDrone> dp88_AR_TerrorDrone_Registrant("dp88_AR_TerrorDrone","");*/
 
 // Remote Control Scripts
-ScriptRegistrant<dp88_RemoteControlConsole> dp88_RemoteControlConsole_Registrant("dp88_RemoteControlConsole","remoteControlID:int,vehiclePreset:string,cost:int,team:int,accessDeniedSound:string,consoleOfflineSound:string,insufficientFundsSound:string,connectionEstablishedSound:string");
+ScriptRegistrant<dp88_RemoteControlConsole> dp88_RemoteControlConsole_Registrant("dp88_RemoteControlConsole","remoteControlID:int,vehiclePreset:string,cost:int,team:int,chargeTime=0:int,accessDeniedSound:string,consoleOfflineSound:string,consoleChargingSound:string,insufficientFundsSound:string,connectionEstablishedSound:string,animationName:string,animFrameAvailable1=0:int,animFrameAvailable2=0:int,animFrameCharging1=0:int,animFrameCharging2=0:int,animFrameActive1=0:int,animFrameActive2=0:int,animFrameIdle1=0:int,animFrameIdle2=0:int,animFrameDisabled1=0:int,animFrameDisabled2=0:int");
 ScriptRegistrant<dp88_RemoteControlVehicle> dp88_RemoteControlVehicle_Registrant("dp88_RemoteControlVehicle","remoteControlID:int");
 
 
diff -uwr source/scripts/dp88_ar.h 4.0/source/scripts/dp88_ar.h
--- source/scripts/dp88_ar.h	2011-06-12 20:51:20.000000000 +0800
+++ 4.0/source/scripts/dp88_ar.h	2011-10-25 07:50:47.747070300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts for the ApocRising total conversion mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 #include "dp88_customAI.h"
 #include "dp88_custom_timer_defines.h"
@@ -47,7 +47,6 @@
 
 
 
-
 // Class for vehicles (redundant, keeping it temporaraily for terror drone code)
 class dp88_AR_Vehicle : public ScriptImpClass
 {
@@ -66,6 +65,12 @@
 };
 
 
+
+
+/*!
+* A companion script for dp88_veterancyUnit which grants units health and/or armour
+* regeneration dependant upon their promotion level (rookie, veteran, elite)
+*/
 class dp88_AR_Veterancy_HealthArmourRegen : public ScriptImpClass
 {
 	void Created( GameObject *obj );
@@ -79,11 +84,11 @@
 
 
 
-
-
-
-
-
+/*!
+* A companion script for dp88_veterancyUnit which grants units a weapon upon creation
+* which can subsequently be upgraded to a more powerful weapon when the player gets
+* promoted
+*/
 class dp88_AR_grantDefaultWeapon : public ScriptImpClass {
 
 	char weaponName[64];
@@ -95,6 +100,8 @@
 };
 
 
+
+
 /*------------------------
 Deployable Infantry script
   Allows an infantry unit to 'deploy', which involves switching to
@@ -144,6 +151,7 @@
 
 
 
+
 /*------------------------
 Chrono Legionnaire
 --------------------------*/
@@ -322,22 +330,77 @@
 
 
 
-/*------------------------
-Remote Control Console script
---------------------------*/
 
+/*!
+* This script is attached to consoles to allow players to take remote control of a drone vehicle
+* which is spawned by the console on demand. The vehicle preset which is spawned must have the
+* dp88_RemoteControlVehicle script attached with a matching remoteControlID parameter to work
+* correctly
+*
+* \param remoteControlID
+*   Shared ID used by the console and drones to enable them to be linked correctly - each vehicle
+*   preset should use a unique ID, but multiple consoles can share that vehicles ID
+* \param vehiclePreset
+*   Name of the vehicle preset to spawn as the drone
+* \param cost
+*   Cost of purchasing a drone when non exists
+* \param team
+*   ID of the team permitted to use this console (0: Nod, 1: GDI, 2: Both)
+* \param chargeTime
+*   Minimum time, in seconds, for the console to charge up before the purchase of a drone is
+*   permitted and to recharge between drone purchases. Set to 0 to disable charging.
+* \param accessDeniedSound
+*   2D sound to play for a player of the wrong team who tries to use the console
+* \param consoleOfflineSound
+*   2D sound to play for a player trying to use a disabled console
+* \param consoleChargingSound
+*   2D sound to play for a player trying to use a console which is charging
+* \param insufficientFundsSound
+*   2D sound to play for a player trying to purchase a drone with insufficient credits
+* \param connectionEstablishedSound
+*   2D sound to play for a player when they successful take control of a drone
+* \param animationName
+*   Name of the animation for the state frames
+* \param animFrameAvailable1
+*   First frame of the animation to play when the console is available (drone ready to purchase)
+* \param animFrameAvailable2
+*   Last frame of the animation to play when the console is available (drone ready to purchase)
+* \param animFrameCharging1
+*   First frame of the animation to play when the console is charging
+* \param animFrameCharging2
+*   Last frame of the animation to play when the console is charging
+* \param animFrameActive1
+*   First frame of the animation to play when the console is in use
+* \param animFrameActive2
+*   Last frame of the animation to play when the console is in use
+* \param animFrameIdle1
+*   First frame of the animation to play when the console is available (drone idle in field)
+* \param animFrameIdle2
+*   Last frame of the animation to play when the console is available (drone idle in field)
+* \param animFrameDisabled1
+*   First frame of the animation to play when the console is disabled
+* \param animFrameDisabled2
+*   Last frame of the animation to play when the console is disabled
+*/
 class dp88_RemoteControlConsole : public ScriptImpClass
 {
 	void Created( GameObject *obj );
 	void Poked ( GameObject *obj, GameObject *poker );
 	void Custom( GameObject *obj, int type, int param, GameObject *sender );
 	void Timer_Expired( GameObject *obj, int number );
+	void SetEnabled ( GameObject* obj, bool state );
 
 	int vehicleID;
 	int pilotID;
-	int pilotDummyID;
+	int m_pilotDummyID;
 	Vector3 pilotDummyPos;
-	bool enabled;
+	bool m_bEnabled;
+	int m_nChargeTime;
+
+	void CreateDummy ( GameObject* pilot, Vector3 position, float facing );
+	void DestroyDummy();
+
+	void HandleDriverExit ( GameObject* obj, GameObject* pilot, GameObject* vehicle );
 };
 
 
diff -uwr source/scripts/dp88_ar_unitScripts.cpp 4.0/source/scripts/dp88_ar_unitScripts.cpp
--- source/scripts/dp88_ar_unitScripts.cpp	2010-09-29 21:34:48.000000000 +0800
+++ 4.0/source/scripts/dp88_ar_unitScripts.cpp	2011-10-22 21:53:45.732421800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Unit specific scripts for the Apocalypse Rising mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,7 +9,6 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
 // Include files
 #include "general.h"
 #include "scripts.h"
diff -uwr source/scripts/dp88_ar_unitScripts.h 4.0/source/scripts/dp88_ar_unitScripts.h
--- source/scripts/dp88_ar_unitScripts.h	2010-09-21 06:27:24.000000000 +0800
+++ 4.0/source/scripts/dp88_ar_unitScripts.h	2011-10-14 22:27:31.918945300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Unit specific scripts for the Apocalypse Rising mod
-	Copyright 2010 Danpaul88, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 #include "dp88_ar.h"
 
